var gPermissionManager, gScreenX, gScreenY, gHeight, gWidth, gFileName = null;
var gPatternPrefPrefix = "multizilla.content-blocker.pattern.for.";
var dsStats = null;

function Startup()
{
  gPermissionManager = window.arguments[0];
  dsStats = window.arguments[1];
  gScreenX = gPermissionManager.screenX;
  gScreenY = gPermissionManager.screenY;
  gHeight = (gPermissionManager.innerHeight / 50 - 2);
  gWidth = gPermissionManager.innerWidth;
  window.outerWidth = gWidth;

  if (gPermissionManager.gUseStackedWindows) {
    document.documentElement.setAttribute("hidechrome", "true");
    window.outerHeight = 0;
    slideOpen(0);
  }
  else {
    document.getElementById("main-box").collapsed = false;
    window.outerWidth = gPermissionManager.outerWidth;
    window.outerHeight = gPermissionManager.outerHeight;
  }
  document.getElementById('mac_button_spring').hidden = !(/Mac/.test(navigator.platform));
  initImportDialog();

  document.getElementById("future-broadcaster").setAttribute("disabled", "true");
}

function slideOpen(aStep) // Modified Phoenix code!
{
  if (aStep < gHeight) {
    window.outerHeight += 50;
    setTimeout(slideOpen, 20, ++aStep);
  } else {
    window.outerHeight = gPermissionManager.innerHeight;
    document.getElementById("main-box").collapsed = false;
  }
}

function slideClosed(aStep) // Modified Phoenix code!
{
  document.getElementById("dialogButtonBox").collapsed = true;

  if (gPermissionManager.gUseStackedWindows && aStep < gHeight) {
    window.outerHeight -= 50;
    setTimeout(slideClosed, 10, ++aStep);
  } else {
    window.close();
  }
}

function initImportDialog()
{
  var newFilters = 0;
  var duplicates = 0;

  for (i in dsStats) {
    var textboxID = dsStats[i].typeID + "-filters";
    var textbox = document.getElementById(textboxID);
    textbox.value = dsStats[i].entries;
    var checkboxID = dsStats[i].typeID + "-checkbox";
    var checkbox = document.getElementById(checkboxID);
    checkbox.checked = (textbox.value > 0);
    checkbox.disabled = (textbox.value == 0);

    var mergedPatterns = {newfilters:0, duplicates:0};
    var permissionType = dsStats[i].typeID;
    var patternsInFile = readPatternsFor(permissionType, dsStats[i].resourceID);
    var patternsInPref = gPermissionManager.getPatternPrefFor(permissionType);
    var radiogroup = document.getElementById(dsStats[i].typeID);

    if (patternsInFile && patternsInFile.length > 0)
      mergedPatterns = mergePatterns(patternsInPref, patternsInFile);
    // Initialize radiogroup based on number of: filters, new filters and merged filters
    if (patternsInPref.length == 0) { // Add new filters from file
      newFilters = textbox.value;
      radiogroup.selectedIndex = 1;
      radiogroup.childNodes[2].disabled = true;
    }
    else {
      if (patternsInPref.length > 0 && mergedPatterns.newfilters == 0) { // Overwrite current Filters
        newFilters = 0;
        radiogroup.selectedIndex = 1;
        radiogroup.childNodes[2].disabled = true;
      }
      else { // Merge filters from file with current filters
        newFilters = mergedPatterns.newfilters;
        radiogroup.selectedIndex = 2;
      }
    }
    textboxID = dsStats[i].typeID + "-newfilters";
    textbox = document.getElementById(textboxID);
    textbox.value = newFilters;
    checkbox.checked = (textbox.value > 0);
    updateBroadcaster(checkbox);
  }
}

function importFilters()
{
  var newFilters = 0;
  var duplicates = 0;
  var addedFilter = 0;
  var alreadyConfirmed = false;

  // Scan through the array for valid type numbers (skips cookies/popups)
  for (var i = 0; i < dsStats.length; i++) {
    var permissionType = dsStats[i].typeID;
    var newPatterns = readPatternsFor(permissionType, dsStats[i].resourceID);

    if (newPatterns && newPatterns.length > 1) {
      var radiogroup = document.getElementById(dsStats[i].typeID);
      var action = radiogroup.selectedIndex;

      if (action == 2) { // Merge Filters
        var prefPatterns = gPermissionManager.getPatternPrefFor(permissionType);
        var result = mergePatterns(prefPatterns, newPatterns);
        newFilters = result.newfilters;
        duplicates += result.duplicates;
        newPatterns = (result.newfilters > 0) ? newPatterns : null;
      }
      else if (action == 1) // Overwrite Filters
        newFilters = newPatterns.length;
      else // Skip filter (checkbox.checked == false)
        newFilters = 0;

      if (newFilters > 0) {
        addedFilter += newFilters;

        var confirmText = (action == 1) ? 'cbImportConfirmOverwrite' : 'cbImportConfirmMerge';

        if (!alreadyConfirmed && !gPermissionManager.getConfirmation(window, 'cbImportManager', confirmText))
          return;
        else if (!alreadyConfirmed) 
          alreadyConfirmed = true;
        setPatternPrefFor(permissionType, newPatterns);
      }
      var textboxID = dsStats[i].typeID + "-newfilters";
      var textbox = document.getElementById(textboxID);
      textbox.value = newFilters;
    }
  }
  // var notification = addedFilter ? "[ " + addedFilter + " ] new filter(s) added from the specified file" : "The specified file contains no new filters";
  var newFiltersMessage = gPermissionManager.permissionsBundle.formatStringFromName('pmNewFiltersMessage', [addedFilter], 1);
  var noNewFiltersMessage = gPermissionManager.permissionsBundle.GetStringFromName('pmNoNewFiltersMessage');
  var notification = addedFilter ? newFiltersMessage : noNewFiltersMessage;
  var duplicatedFiltersMessage = gPermissionManager.permissionsBundle.formatStringFromName('pmDuplicatedFiltersMessage', [duplicates], 1);
  // notification += (addedFilter && duplicates) ? "\n[ " + duplicates + " ] duplicate(s) skipped from the specified file" : "";
  notification += (addedFilter && duplicates) ? duplicatedFiltersMessage : "";
  var title = gPermissionManager.permissionsBundle.GetStringFromName('cbImportFinished');
  gPermissionManager.promptService.alert(window, title, notification);
  finishImport();
}

function finishImport()
{
  for (i in dsStats) {
    var checkboxID = dsStats[i].typeID + "-checkbox";
    var checkbox = document.getElementById(checkboxID);
    checkbox.disabled = true;

    var radiogroupID = dsStats[i].typeID;
    var radiogroup = document.getElementById(radiogroupID);
    radiogroup.childNodes[1].disabled = true;
    radiogroup.childNodes[2].disabled = true;

    document.getElementById('disableBroadcaster').setAttribute('disabled', 'true');
  }
  var importButton = document.getElementById('ImportButton');
  var acceptButton = document.documentElement.getButton('accept');
  var cancelButton = document.documentElement.getButton('cancel');

  importButton.removeAttribute('default');
  importButton.setAttribute('disabled', 'true');
  acceptButton.removeAttribute('default');

  cancelButton.label = gPermissionManager.permissionsBundle.GetStringFromName('cbBackButton.label');
  cancelButton.setAttribute('default', 'true');
  cancelButton.focus();
}

function readPatternsFor(type, resourceID)
{
  // var index = 0;
  var patterns = new Array();
  var entries = gPermissionManager.cbEntries(resourceID).GetElements();

  if (!entries.hasMoreElements()) {
    // Fallback for MultiZilla versions prior to 1.6.3.1 revision D
    resourceID = "urn:" + type;
    entries = gPermissionManager.cbEntries(resourceID).GetElements();

    if (!entries.hasMoreElements())
      return null;
  }
  while (entries.hasMoreElements()) {
    var rdfData = entries.getNext();

    if (rdfData) {
      try {
        rdfData = rdfData.QueryInterface(Components.interfaces.nsIRDFLiteral);
        // index++;
      } catch(ex) {
        dump("\nErrror Query to nsIRDFLiteral failed!");
        continue;
      }
      patterns.push(rdfData.Value);
    }
  }
  return patterns.sort();
}

function mergePatterns(currentPatterns, newPatterns)
{
  var patternCount = newPatterns.length;
  var patternString = String(currentPatterns);
  var statistics = new Object();

  statistics.duplicates = 0;
  statistics.newfilters = 0;

  for (var i = 0; i < patternCount; i++) {
    var isNew = true;
    var currentPatternCount = currentPatterns.length;

    if (patternString.indexOf(newPatterns[i]) > -1) { // Do a quick search (saves us cycles)
      // Possible match. Scan pattern array for exact match
      for (var x = 0; x < currentPatternCount; x++) {
        if (newPatterns[i] == currentPatterns[x]) { // Is this a new pattern?
          statistics.duplicates++;
          isNew = false; // No
          break; // Skip this pattern
        }
      }
    }
    if (isNew) {
      statistics.newfilters++;
      currentPatterns.push(newPatterns[i]);
      patternString = String(currentPatterns);
    }
  }
  currentPatterns.sort();
  return statistics;
}

function setPatternPrefFor(type, patterns)
{
  var pattern = "";

  for (var p = 0; p < patterns.length; p++) {
    if (patterns[p].length) // prevent adding useless/spurious ", "
      pattern += patterns[p] + ", "; // The extra space is to make wrap work!
  }
  pattern = pattern.replace(/, $/, ''); // Remove trailing space and comma
  var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
  str.data = pattern;
  gPermissionManager.pref.setComplexValue(gPatternPrefPrefix + type, Components.interfaces.nsISupportsString, str);
  patterns = null;
}

function updateBroadcaster(element)
{
  var disabled = 0;
  var radiogroupID = element.getAttribute('radiogroup');
  var radiogroup = document.getElementById(radiogroupID);
  var newFilters = document.getElementById(radiogroupID + "-newfilters").value;
  var defaultSelector = (newFilters > 0) ? 2 : 1;
  radiogroup.selectedIndex = element.checked ? defaultSelector : 0;
  radiogroup.childNodes[1].disabled = (radiogroup.selectedIndex < 1)
  radiogroup.childNodes[2].disabled = (radiogroup.selectedIndex < 1  || defaultSelector == 1)

  var broadcasterID = element.getAttribute('broadcaster');
  var broadcaster = document.getElementById(broadcasterID);
  broadcaster.setAttribute('disabled', element.checked ? "false" : "true");

  if (element.checked)
    disableContraField(radiogroup);

  for (i in dsStats) {
    var checkboxID = dsStats[i].typeID + "-checkbox";
    var checkbox = document.getElementById(checkboxID);

    if (!checkbox.checked)
      disabled++
  }
  document.getElementById('ImportButton').setAttribute('disabled', (disabled == dsStats.length) ? 'true' : 'false');
}

function disableContraField(aRadioGroup)
{
  var id = aRadioGroup.id;
  var index = aRadioGroup.selectedIndex;

  document.getElementById(id + "-filters").disabled = (index == 2);
  document.getElementById(id + "-label-filters").disabled = (index == 2);
  document.getElementById(id + "-newfilters").disabled = (index == 1);
  document.getElementById(id + "-label-newfilters").disabled = (index == 1);
}
